\section{Approach: Allowing Semantic Similarity in Reviews}

\begin{frame}{A Lexical Database: \wordnet}
\begin{figure}
\centering
\includegraphics[width=\linewidth,height=0.8\textheight,keepaspectratio]{wordnet2.png}
\end{figure}
\end{frame}

\begin{frame}{\wordnet Methods}
Finding synonyms of \alt<1>{\fboxc{background}{\triple{location}{fantastic}}}{\fboxc{red}{\triple{location}{fantastic}}} with \wordnet:
\vspace*{0.6em}

\hspace*{-1.3em}\makebox[\linewidth][c]{%
\begin{minipage}{.30\textwidth}
		\begin{forest}
		for tree={
			grow'=0,
			child anchor=west,
			parent anchor=south,
			anchor=west,
			calign=first,
			edge path={
				\noexpand\path [draw, \forestoption{edge}]
				(!u.south west) +(10pt,0) |- node[fill,inner sep=1pt] {} (.child anchor)\forestoption{edge label};
			},
			before typesetting nodes={
				if n=1
				{insert before={[,phantom]}}
				{}
			},
			fit=band,
			before computing xy={l=20pt},
		}
		[\emphq{fantastic}
		[Synset 1
		[Lemmas]
		[Attributes
		[See Also]
		[Similar To]
		]
		]	
		[Synset 2
		[Lemmas]
		[...]
		]
		]
	\end{forest}
\end{minipage}%
\hspace*{0.8em}
\begin{minipage}{.65\textwidth}
	\centering
	\begin{tabularb}
	\unsyn & \unsynsim & \unsynsyn & \unsynsynsim \vspace{0.3em}\\
	\hline
	&&&\vspace{-0.3em}\\
	\gridon
	\checkmark & \checkmark & \checkmark + UnSyn & \checkmark + UnSynSim\\
	\gridon
	&&&\\
	\gridon
	\checkmark & \checkmark & \checkmark + UnSyn & \checkmark + UnSynSim\\
	\gridon
	 & \checkmark &  & \checkmark + UnSynSim\\
	\gridon
	&&&\\
	\gridon
	\checkmark & \checkmark & \checkmark + UnSyn & \checkmark + UnSynSim\\
	\gridon
	$\ldots$ & $\ldots$ & $\ldots$  & $\ldots$\\
	\gridon
	\end{tabularb}
\end{minipage}
}
\vspace*{-0.5em}
\begin{center}
\onslide<2> \fboxc{red}{\textit{e.g. (\triple{location}{marvelous}, \triple{location}{great}, \triple{location}{grotesque}, $\ldots$)}}\\
\onslide<1-> \fboxc{background}{$\cap$ \emphq{location} triples in data set}\\
\onslide<2> \fboxc{red}{\textit{e.g. (\triple{location}{marvelous}, \triple{location}{great}, $\ldots$)}}
\end{center}
\end{frame}

\begin{frame}[t]{Word Embeddings: \spacy}
\only<1>{\begin{figure}
	\centering
	\begin{tikzpicture}[yscale=0.35, xscale=0.35]
	\draw[thin,gray!40] (-8,-8) grid (12,8);
	\draw[->] (-1,-4)--(-1,8) node[above]{$z$};
	\draw[->] (-1,-4)--(-8,-8) node[above]{$x$};
	\draw[->] (-1,-4)--(12,-8) node[above]{$y$};
	\node [label=above:fantastic,draw,fill=colorone,circle,inner sep=0pt,minimum size=2pt] at (1,1) {};
	\node [label=above:great,draw,fill=colortwo,circle,inner sep=0pt,minimum size=2pt] at (3,0) {};
	\node [label=above:green,draw,fill=colorthree,circle,inner sep=0pt,minimum size=2pt] at (8,-4) {};
	\node [label=above:clean,draw,fill=colorfour,circle,inner sep=0pt,minimum size=2pt] at (-3,0) {};
	\node [label=above:aggressive,draw,fill=colorfive,circle,inner sep=0pt,minimum size=2pt] at (-5,-5) {};
	\node [label=above:nice,draw,fill=colorsix,circle,inner sep=0pt,minimum size=2pt] at (5,4) {};
	\end{tikzpicture}
\end{figure}}
\only<2->{\begin{figure}
		\centering
		\begin{tikzpicture}[yscale=0.35, xscale=0.35]
		\draw[thin,gray!40] (-8,-8) grid (12,8);
		\draw[->] (-1,-4)--(-1,8) node[above]{$z$};
		\draw[->] (-1,-4)--(-8,-8) node[above]{$x$};
		\draw[->] (-1,-4)--(12,-8) node[above]{$y$};
		\node [label=above:fantastic,draw,fill=colorone,circle,inner sep=0pt,minimum size=2pt] at (1,1) {};
		\node [label=above:great,draw,fill=colortwo,circle,inner sep=0pt,minimum size=2pt] at (3,0) {};
		\node [label=above:green,draw,fill=colorthree,circle,inner sep=0pt,minimum size=2pt] at (8,-4) {};
		\node [label=above:clean,draw,fill=colorfour,circle,inner sep=0pt,minimum size=2pt] at (-3,0) {};
		\node [label=above:aggressive,draw,fill=colorfive,circle,inner sep=0pt,minimum size=2pt] at (-5,-5) {};
		\node [label=above:nice,draw,fill=colorsix,circle,inner sep=0pt,minimum size=2pt] at (5,4) {};
		
		\draw[line width=1pt,colorone,-stealth](-1,-4)--(1,1);
		\draw[line width=1pt,colortwo,-stealth](-1,-4)--(3,0);
		\draw (-0.14,-2) arc (70:25:1);
		\node[] at (0.5,-1.5)  {$\theta$};
		\end{tikzpicture}
	\end{figure}
	\begin{center}
		\text{Cosine Similarity} = $\cos(\theta)$
\end{center}}
\end{frame}

\begin{frame}{\spacy Methods}
Finding synonyms of \alt<1>{\fboxc{background}{\triple{location}{fantastic}}}{\fboxc{red}{\triple{location}{fantastic}}} with \spacy, considering the word vectors
\vspace{-\topsep}
\begin{itemize}
	\item \avec of adjective $adj$
	\item \fvec of \emphq{fantastic}
	\item \lvec of \emphq{location}
\end{itemize}
\begin{description}
	\item[\spacya:] $cos(\avec, \fvec) \hspace*{\fill} \geq 0.7$
	\item[\spacyone:] $cos(\avec, \fvec + \lvec) \hspace*{\fill} \geq 0.7$
	\item[\spacytwo:] $cos(\avec + \lvec, \fvec + \lvec) \hspace*{\fill} \geq 0.7$
	\item[\spacyinter:] $cos(\avec, \fvec)\text{ and } cos(\avec, \lvec) \hspace*{\fill} \geq 0.7$
	\item[\spacydocs:] $cos(doc(\text{\triple{location}{\textit{adj}}}),doc(\text{\triple{location}{fantastic}})) \hspace*{\fill} \geq 0.7$
\end{description}
\begin{center}
	\vspace{0.3em}
	\onslide<2> \fboxc{red}{\textit{e.g. (\triple{location}{marvelous}, \triple{location}{awful}, \triple{location}{tasty}, $\ldots$)}}\\
	
	\onslide<1->\fboxc{background}{$-$ antonym\_triples(\triple{location}{fantastic})}\\
	
	\onslide<2> \fboxc{red}{\textit{e.g. (\triple{location}{marvelous},\triple{location}{tasty}, $\ldots$)}}\\
	
	\onslide<1-> \fboxc{background}{$\cap$ \emphq{location} triples in data set}\\
	\onslide<2> \fboxc{red}{\textit{e.g. (\triple{location}{marvelous}, $\ldots$)}}
\end{center}
\end{frame}


\begin{frame}{Differentiating Intensities of Adjectives}
\sentiwordnet: \wordnet + polarities\\
\wordvec: Word embeddings + analogies
\vspace*{0.3em}

Approaches:
\begin{enumerate}
	\item Adjectives in the neighbourhood of \emphq{good} and \emphq{bad}\\ordered with \sentiwordnet
	\vspace{0.2em}
	
	\resizebox{\linewidth}{!}{
		\begin{tikzpicture}
		\node at (0, 0.5) {0};
		\node at (6, 0.5) {Positive};
		\node at (-6, 0.5) {Negative};
		\node [process, align=flush center, text height= 1.3cm] at (1.5, 0) {good};
		\node [process, align=flush center, text height= 1.3cm] at (3, 0) {superb};
		\node [process, align=flush center, text height= 1.23cm] at (4.5, 0) {excellent};
		\node [process, align=flush center, text height= 1.3cm] at (-1.5, 0) {bad};
		\node [process, align=flush center, text height= 1.3cm] at (-3, 0) {terrible};
		\node [process, align=flush center, text height= 1.3cm] at (-4.5, 0) {horrific};
		\node [process, align=flush center] at (1.5, -1) {0.63};
		\node [process, align=flush center] at (3, -1) {0.87};
		\node [process, align=flush center] at (4.5, -1) {1.0};
		\node [process, align=flush center] at (-1.5, -1) {-0.57};
		\node [process, align=flush center] at (-3, -1) {-0.67};
		\node [process, align=flush center] at (-4.5, -1) {-0.79};
		
		\draw [line width=2.5pt, ->,colorthree, >=stealth] (0,0) -- (6,0);
		\draw [line width=2.5pt, ->,colorone, >=stealth] (0,0) -- (-6,0);
		\end{tikzpicture}}
	\item Use the reference scale to learn a scale by analogy with \wordvec
	\vspace{0.5em}
	\begin{center}
	good : superb = friendly : x
	\end{center}
	\resizebox{\linewidth}{!}{
		\begin{tikzpicture}
		\node at (0, 0.5) {0};
		\node at (6, 0.5) {Positive};
		\node at (-6, 0.5) {Negative};
		\node [process, align=flush center, text height= 1.3cm] at (1.1, 0) {friendly};
		\node [process, align=flush center, text height= 1.3cm] at (2.7, 0) {delightful};
		\node [process, align=flush center, text height= 1.23cm] at (4.5, 0) {friendliest};
		\node [process, align=flush center, text height= 1.3cm] at (-1.5, 0) {unfriendly};
		\node [process, align=flush center, text height= 1.3cm] at (-3, 0) {ghastly};
		\node [process, align=flush center, text height= 1.3cm] at (-4.5, 0) {hostile};
		\draw [line width=2.5pt, ->,colorthree, >=stealth] (0,0) -- (6,0);
		\draw [line width=2.5pt, ->,colorone, >=stealth] (0,0) -- (-6,0);
		\end{tikzpicture}}
	\begin{center}
		x = delightful
	\end{center}
\end{enumerate}
\end{frame}